﻿using Falcon.SugarApi.BackTask;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;

namespace $safeprojectname$.Tasks
{
    /// <summary>
    /// 后台任务基类
    /// </summary>
    public abstract class TaskBase:BackgroundLongTask
    {
        /// <summary>
        /// 应用配置
        /// </summary>
        public $safeprojectname$Options Options { get; set; }
        /// <summary>
        /// 日志记录
        /// </summary>
        public ILogger Logger { get; set; }

        /// <inheritdoc/>
        public TaskBase(IServiceProvider service) {
            this.Options = service.GetRequiredService<$safeprojectname$Options>();
            Logger = (service.GetService(typeof(ILogger<>).MakeGenericType(GetType())) as ILogger) ?? throw new NullReferenceException("ILogger");
        }

        /// <inheritdoc/>
        protected override abstract bool Run();

        /// <inheritdoc/>
        protected override void OnException(BackgroundLongTask t,Exception ex) {
            var msg = ex.ToString();
            this.Logger.LogError($"运行任务期间发生异常！\n{msg}");
        }
    }
}
